# UCC Hypergraphs

This is an archive for hypergraphs that occur in the enumeration of unique column combinations (UCCs) relational databases.


## Description

The archive contains data from six different databases:
- *booking_call_a_bike*
- *civil_service_list*
- *fd_reduced_30*
- *hackathon_efficiency_call_a_bike*
- *ncvoter_allc*
- *passagierzahlen*

Each data sample comes in two versions, one with 100 000 records (rows) drawn uniformly at random from the original source,
and a smaller version including the first 10 000 records.
For every version, there is one hypergraph having as edges the minimal difference sets for all pairs of records
and one hypergraph containing the minimal UCCs.
The two hypergraphs corresponding to one version are mutually dual in the sense that one consists of the minimal hitting sets of the other. 

The attributes (columns) of the databases are numbered with 0-based indices.
This numbering is used consistently throughout all files referring to the same database.
For example, the vertex having ID 3 in the file `10k_civil_service_list_diff.graph`
is the same as vertex 3 in `10k_civil_service_list_UCC.graph`, `100k_civil_service_list_diff.graph`, and `100k_civil_service_list_UCC.graph`.
All these vertices correspond to the fourth attribute in the *civil_service_list* database (i.e., the middle initial).

## Content

- `readme.md`: This file.
- `sources.txt`: The online references of the databases.
- **tables**: The databases in both versions as `csv`-files.
	- Filenames have the form `10[0]k_*.csv`.
	- Prefix `10k` or `100k` indicates the version.
	- `*` stands for the name of the database.
- **differenceGraphs**: The hypergraph of minimal difference sets as `graph`-files.
	- Filenames have the form `10[0]k_*_diff.graph`
- **transversalGraphs**: The hypergraph of minimal UCCs as `graph`-files.
	- Filenames have the form `10[0]k_*_UCC.graph`
	
## The GRAPH File Format

A `graph`-file describes a hypergraph as a list of (hyper-)edges.
The first line shows the total number of vertices.
Note that this number may be larger than the number of vertices appearing in any edge.
It is followed by a list of edges in lexicographical order as comma-separated vertex IDs, one line per edge.
An empty edge is indicated by a comma on a single line.
The file is concluded by a blank line. 